;*********************************
;    Webcam by Siekmanski 2006    
;*********************************

	.386
	.model flat,stdcall
	 option casemap:none

	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include vfw32\vfw32.inc
	
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib vfw32\vfw32.lib


TEXT_ MACRO your_text:VARARG
	LOCAL text_string
	.data
	 text_string db your_text,0
	.code
	EXITM <addr text_string>
ENDM


CAPDRIVERCAPS struct
	wDeviceIndex    		dd ?
	fHasOverlay    			dd ?
	fHasDlgVideoSource		dd ?
	fHasDlgVideoFormat		dd ?
	fHasDlgVideoDisplay		dd ?
	fCaptureInitialized		dd ?
	fDriverSuppliesPalettes	dd ?
	hVideoIn				dd ?
	hVideoOut				dd ?
	hVideoExtIn				dd ?
	hVideoExtOut			dd ?
CAPDRIVERCAPS ends

CAPSTATUS struct
	uiImageWidth			dd ?
	uiImageHeight			dd ?
	fLiveWindow				dd ?
	fOverlayWindow			dd ?
	bfScale					dd ?
	ptScroll				POINT <?>
	fUsingDefaultPalette	dd ?
	fAudioHardware			dd ?
	fCapFileExists			dd ?
	dwCurrentVideoFrame		dd ?
	dwCurrentVideoFramesDropped	dd ? 
	dwCurrentWaveSamples	dd ?
	dwCurrentTimeElapsedMS	dd ?
	hPalCurrent				dd ?
	fCapturingNow			dd ?
	dwReturn				dd ?
	wNumVideoAllocated		dd ?
	wNumAudioAllocated		dd ?
CAPSTATUS ends

camera_combo			equ	200
camera_screen			equ	201
camera_source			equ 202
camera_format			equ 203
camera_display			equ 204
save_bmp				equ 205

FramesPerSecond			equ 30
       
.data?

hInstance				dd	?
hWnd					dd	?
CaptureCaps				CAPDRIVERCAPS <?>
CaptureStatus			CAPSTATUS <?>
dwCaptureDeviceCount	dd	?
hCaptureDevice			dd	?
hCaptureCombobox		dd	?
hCaptureWnd				dd	?
dwPic_number			dd	?
szString_buffer			db	128 dup (?)

.code

InitCaptureDevice proc
	
	invoke	SendMessage,hCaptureWnd,WM_CAP_DRIVER_CONNECT,hCaptureDevice,0
	invoke	SendMessage,hCaptureWnd,WM_CAP_DRIVER_GET_CAPS,sizeof CaptureCaps,addr CaptureCaps
	invoke	SendMessage,hCaptureWnd,WM_CAP_SET_PREVIEW,TRUE,0
	invoke	SendMessage,hCaptureWnd,WM_CAP_SET_PREVIEWRATE,1000/FramesPerSecond,0
	invoke	SendMessage,hCaptureWnd,WM_CAP_SET_SCALE,TRUE,0
	invoke	SendMessage,hCaptureWnd,WM_CAP_SET_OVERLAY,TRUE,0
	ret
InitCaptureDevice endp

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	.if	uMsg == WM_INITDIALOG
		mov		eax,hWin
		mov		hWnd,eax

		invoke	GetDlgItem,hWnd,camera_combo
		mov		hCaptureCombobox,eax

        ; Zoek alle aanwezige video_opname apparaten

		mov		[dwCaptureDeviceCount],0
		invoke	SendMessage,hCaptureCombobox,CB_ADDSTRING,0,TEXT_("Geen camera")
next_capture_device:
		invoke	capGetDriverDescription,dwCaptureDeviceCount,addr szString_buffer,sizeof szString_buffer,0,0
		test	eax,eax
		jz		thats_all
		invoke	SendMessage,hCaptureCombobox,CB_ADDSTRING,0,addr szString_buffer
		invoke	RtlZeroMemory,addr szString_buffer,sizeof szString_buffer
		inc		[dwCaptureDeviceCount]
		jmp		next_capture_device
thats_all:

		.if	dwCaptureDeviceCount == 0
			invoke	MessageBox,hWin,TEXT_("Geen capture devices gevonden !",13,10,"programma wordt beeindigd...."), \
					TEXT_("Siekmanski zegt: Helaas pindakaas....?"),MB_OK OR MB_ICONWARNING ;MB_ICONERROR
			jmp	sluitprog
		.endif

		invoke	SendMessage,hCaptureCombobox,CB_SETCURSEL,1,0

		invoke	GetDlgItem,hWnd,camera_screen
		invoke	capCreateCaptureWindow,0,WS_CHILD OR  WS_VISIBLE,0,0,320,240,eax,0		;windowhandle in eax
		.if eax == NULL
			invoke	MessageBox,hWin,TEXT_("Kan geen Video CaptureWindow maken !",13,10,"programma wordt beeindigd...."), \
					TEXT_("Siekmanski zegt: Helaas....?"),MB_OK OR MB_ICONWARNING ;MB_ICONERROR
			jmp	sluitprog
		.endif

	mov		hCaptureWnd,eax
   
    mov		dwPic_number,0
   	mov		hCaptureDevice,0

	; Probeer eerste opnamebron die we vinden

	invoke	InitCaptureDevice

;	invoke	SendMessage,hCaptureWnd,WM_CAP_GET_STATUS,sizeof CaptureStatus,addr CaptureStatus
;		.if (CaptureStatus.fLiveWindow == FALSE)
;			invoke	MessageBox,hWin,TEXT_("Geen LiveWindow !",13,10,"Testing...."), \
;			TEXT_("Siekmanski zegt: Helemaal niets....?"),MB_OK OR MB_ICONWARNING ;MB_ICONERROR
;		.endif

	.elseif uMsg == WM_COMMAND
		mov		eax,wParam
		mov		ecx,eax
        shr		ecx,16
        
		.if ecx == CBN_SELCHANGE      
			mov		eax,lParam
			.if eax == hCaptureCombobox
				invoke	SendMessage,hCaptureWnd,WM_CAP_DRIVER_DISCONNECT,0,0
				invoke	SendMessage,hCaptureCombobox,CB_GETCURSEL,0,0
				.if eax == 0
					invoke	SendMessage, hCaptureWnd,WM_CAP_DRIVER_DISCONNECT,0,0
				.endif

				dec 	eax
				mov		hCaptureDevice,eax
				invoke	InitCaptureDevice
			.endif

		.elseif eax == camera_source     ; cam instellingen
            	.if (CaptureCaps.fHasDlgVideoSource)
					invoke	SendMessage,hCaptureWnd,WM_CAP_DLG_VIDEOSOURCE,0,0
               	.endif

		.elseif eax == camera_format     ; cam instellingen
				.if (CaptureCaps.fHasDlgVideoFormat)
					invoke	SendMessage,hCaptureWnd,WM_CAP_DLG_VIDEOFORMAT,0,0
				.endif

		.elseif eax == camera_display     ; cam instellingen
				.if (CaptureCaps.fHasDlgVideoDisplay)
					invoke	SendMessage,hCaptureWnd,WM_CAP_DLG_VIDEODISPLAY,0,0
				.endif

		.elseif eax == save_bmp     
				inc		dwPic_number 
				invoke  wsprintf,addr szString_buffer,TEXT_("Plaatje_%d.bmp",0),dwPic_number
				invoke  SendMessage,hCaptureWnd,WM_CAP_FILE_SAVEDIBA,0,addr szString_buffer
		.endif

	.elseif uMsg == WM_CLOSE
		invoke SendMessage,hCaptureWnd,WM_CAP_DRIVER_DISCONNECT,0,0
sluitprog:
		invoke EndDialog,hWin,0

	.else
		mov		eax,FALSE
		ret
	.endif

    mov		eax,TRUE
	ret
DlgProc endp

start:
	invoke	GetModuleHandle,NULL
	mov		hInstance,eax
	invoke	DialogBoxParam,hInstance,TEXT_("camera"),0,addr DlgProc,0
	invoke	ExitProcess,eax
end start
